using System;
using System.IO;

namespace UploadFileChunk
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			string UserID = "xxxxx";
			string Password = "xxxxx";
			string FaxNumber = "xxxxx";
			string Path = "c://temp//2.pdf";	// path to the file to be uploaded
			string SessionID="";
			int chunkSize = 30000;

			// read the file into a byte array

			FileStream fs = new FileStream(Path, FileMode.Open, FileAccess.Read);

			interfax.InterFax ws = new interfax.InterFax();
			ws.StartFileUpload(UserID,Password,ref SessionID);

			// loop until all file data is read
			bool isLast = false;
			int readSoFar = 0;
			while (!isLast)
			{
				byte[] B = new byte[chunkSize];	//this is max buffer size
				int read = fs.Read(B,0, B.Length);
				readSoFar += read;
				isLast = (readSoFar==fs.Length);
				if (read<B.Length)	// a partial buffer was read => trim B
				{
					byte[] B1 = new byte[read];	//this is max buffer size
					for (int i=0; i<read; i++) B1[i] = B[i];
					ws.UploadFileChunk(SessionID,B1,isLast);
				} 
				else
					ws.UploadFileChunk(SessionID,B,isLast);
			}

			long Result = ws.SendfaxEx_2(UserID,Password,FaxNumber,"",null,"pdf",readSoFar.ToString() + "/sessionID=" + SessionID,DateTime.MinValue,1,"CSID","","","My Subject","","A4","Portrait",false,true);
			Console.WriteLine("Result is {0}",Result);
		}
	}
}
